cowboy_req:set_resp_headers(3)

NAME

cowboy_req:set_resp_headers - Set several response headers

DESCRIPTION
    set_resp_headers(Headers, Req :: cowboy_req:req())
        -> Req

    Headers :: cowboy:http_headers() | [{binary(), iodata()}]

Set several headers to be sent with the response.

The header name must be given as a lowercase binary string. While header names are case insensitive, Cowboy requires them to be given as lowercase to function properly.

Cowboy does not allow duplicate header names. Headers set by this function may be overwritten by those set from the reply functions. Likewise, headers set by this function may overwrite headers that were set previously.

Use cowboy_req:set_resp_cookie(3) instead of this function to set cookies.

ARGUMENTS

Headers
    Headers as a map with names being lowercase binary strings, and values as iodata; or as a list with the same requirements for names and values.

    When a list is given it is converted to its equivalent map, with duplicate headers concatenated with a comma inserted in-between. Support for lists is meant to simplify using data from clients or other applications.

    The set-cookie header must not be set using this function.

Req
    The Req object.

RETURN VALUE

A new Req object is returned.

The returned Req object must be used from that point onward, otherwise the headers will not be sent in the response.

CHANGELOG
    • 2.13: The function now accepts a list of headers.
    • 2.0: Function introduced.

EXAMPLES

Set several response headers
    Req = cowboy_req:set_resp_headers(#{
        <<"content-type">>     => <<"text/html">>,
        <<"content-encoding">> => <<"gzip">>
    }, Req0).

SEE ALSO

cowboy_req(3), cowboy_req:set_resp_cookie(3), cowboy_req:set_resp_header(3), cowboy_req:has_resp_header(3), cowboy_req:resp_header(3), cowboy_req:resp_headers(3), cowboy_req:delete_resp_header(3), cowboy_req:reply(3), cowboy_req:stream_reply(3)